//+------------------------------------------------------------------+
//|                                            OneSideGaussianMA.mq5 | 
//|                                         Copyright  2008, mladen | 
//|                                                mladenfxgmail.com | 
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, mladen"
#property link "mladenfxgmail.com"
//----   
#property version   "1.00"
#property description "    "
//----     
#property indicator_chart_window
//----        
#property indicator_buffers 2
//----     
#property indicator_plots   1
//+-----------------------------------+
//|       |
//+-----------------------------------+
//----     
#property indicator_type1   DRAW_COLOR_LINE
//----      
#property indicator_color1  clrDeepPink,clrGray,clrMediumSlateBlue
//----   -  
#property indicator_style1  STYLE_SOLID
//----     2
#property indicator_width1  2
//----   
#property indicator_label1  "OneSideGaussianMA"
//+-----------------------------------+
//|           |
//+-----------------------------------+
#include <OneSideGaussianLibrary.mqh> 
//+-----------------------------------+
//|                 |
//+-----------------------------------+
#define RESET 0 //        
//#define MAXLENGTH 34 //       
//+-----------------------------------+
//|             |
//+-----------------------------------+
/*
enum Applied_price_
  {
   PRICE_CLOSE_ = 1,     //Close
   PRICE_OPEN_,          //Open
   PRICE_HIGH_,          //High
   PRICE_LOW_,           //Low
   PRICE_MEDIAN_,        //Median Price (HL/2)
   PRICE_TYPICAL_,       //Typical Price (HLC/3)
   PRICE_WEIGHTED_,      //Weighted Close (HLCC/4)
   PRICE_SIMPL_,         //Simpl Price (OC/2)
   PRICE_QUARTER_,       //Quarted Price (HLOC/4) 
   PRICE_TRENDFOLLOW0_,  //TrendFollow_1 Price 
   PRICE_TRENDFOLLOW1_,  //TrendFollow_2 Price 
   PRICE_DEMARK_         //Demark Price
  };
//+-----------------------------------+
//|             |
//+-----------------------------------+
enum SmoothMode
  {
   Smooth1 = 0,
   Smooth2,
   Smooth3,
   Smooth4,
   Smooth5,
   Smooth6,
   Smooth7,
   Smooth8
  };
*/
//+-----------------------------------+
//|         |
//+-----------------------------------+
input SmoothMode SmoothType=Smooth6; // 
input Applied_price_ IPC=PRICE_CLOSE_;// 
input int Shift=0; //      
//+-----------------------------------+

//----   ,    
//      
double IndBuffer[];
double ColorIndBuffer[];
//----      
int min_rates_total;
//+------------------------------------------------------------------+   
//| Custom indicator initialization function                         | 
//+------------------------------------------------------------------+ 
void OnInit()
  {
//----     
   min_rates_total=MAXLENGTH*2+1;
   GaussianInit();

//----      
   SetIndexBuffer(0,IndBuffer,INDICATOR_DATA);
//----    1  
   PlotIndexSetInteger(0,PLOT_SHIFT,Shift);
//----      
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,min_rates_total);
//----   ,      
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,0);
//----    ,   
   ArraySetAsSeries(IndBuffer,true);

//----     ,     
   SetIndexBuffer(1,ColorIndBuffer,INDICATOR_COLOR_INDEX);
//----      
   PlotIndexSetInteger(1,PLOT_DRAW_BEGIN,min_rates_total);
//----    1  
   PlotIndexSetInteger(1,PLOT_SHIFT,Shift);
//----    ,   
   ArraySetAsSeries(ColorIndBuffer,true);

//----      
   string shortname;
   StringConcatenate(shortname,"One side Gaussian MA (",EnumToString(SmoothType),", ",EnumToString(IPC),", ",Shift,")");
//---           
   IndicatorSetString(INDICATOR_SHORTNAME,shortname);

//---     
   IndicatorSetInteger(INDICATOR_DIGITS,_Digits);
//----  
  }
//+------------------------------------------------------------------+ 
//| Custom indicator iteration function                              | 
//+------------------------------------------------------------------+ 
int OnCalculate(
                const int rates_total,    //       
                const int prev_calculated,//       
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[]
                )
  {
//----       
   if(rates_total<min_rates_total) return(RESET);

//----       
   double ;
//----        
   int limit,bar;

//----      
//  limit    
   if(prev_calculated>rates_total || prev_calculated<=0)//      
      limit=rates_total-min_rates_total-1; //      
   else limit=rates_total-prev_calculated; //      
   
//----         
   ArraySetAsSeries(open,true);
   ArraySetAsSeries(low,true);
   ArraySetAsSeries(high,true);
   ArraySetAsSeries(close,true);


//----    
   for(bar=limit; bar>=0 && !IsStopped(); bar--) IndBuffer[bar]=Smooth(SmoothType,rates_total,IPC,bar,open,low,high,close);
//----  
   if(prev_calculated<=0) limit--;

//----    
   for(bar=limit; bar>=0 && !IsStopped(); bar--)
     {
      if(IndBuffer[bar+1]<IndBuffer[bar]) ColorIndBuffer[bar]=2;
      else if(IndBuffer[bar+1]>IndBuffer[bar]) ColorIndBuffer[bar]=0;
      else ColorIndBuffer[limit]=1;
     }
//----     
   return(rates_total);
  }
//+------------------------------------------------------------------+
